using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class CastleField : BackGroundBase
{
	public override int FieldId => 2;

	public CastleField(string bgmId = "NONE")
		: base(bgmId)
	{
	}

	protected override void BattleFieldBuild()
	{
		BattleCoroutine.GetInstance().StartCoroutine(BackGroundBase.ObjectChecker(0.5f, _str3DFieldPath, delegate
		{
			base.Field = GameObject.Find(_str3DFieldPath);
			base.Field.transform.parent = GameMgr.GetIns().m_GameManagerObj.transform;
			GimicAudioList = base.Field.GetComponent<AudioList>().GimicAudioList;
			_fieldModel = base.Field.transform.Find("md_bf_ocsl_root").gameObject;
			_fieldParticles = _fieldModel.transform.Find("Particles02").gameObject;
			_fieldObjDictionary.Add(_fieldParticles.name, _fieldParticles);
			_fieldObjDictionary.Add("coffin", _fieldModel.transform.Find("md_bf_ocsl_01_coffin").gameObject);
			_fieldObjDictionary.Add("sword", _fieldModel.transform.Find("md_bf_ocsl_01_sword").gameObject);
			_fieldObjDictionary.Add("tapestry_a", _fieldModel.transform.Find("md_bf_ocsl_01_tapestry_a").gameObject);
			_fieldObjDictionary.Add("tapestry_b", _fieldModel.transform.Find("md_bf_ocsl_01_tapestry_b").gameObject);
			_fieldObjDictionary.Add("chain_a", _fieldModel.transform.Find("md_bf_ocsl_01_chain_a").gameObject);
			_fieldObjDictionary.Add("chain_b", _fieldModel.transform.Find("md_bf_ocsl_01_chain_b").gameObject);
			_fieldObjDictionary.Add("chain_c", _fieldModel.transform.Find("md_bf_ocsl_01_chain_c").gameObject);
			_fieldObjDictionary.Add("chain_d", _fieldModel.transform.Find("md_bf_ocsl_01_chain_d").gameObject);
			_fieldObjDictionary.Add("chain_e", _fieldModel.transform.Find("md_bf_ocsl_01_chain_e").gameObject);
			_fieldObjDictionary.Add("grate", _fieldModel.transform.Find("md_bf_ocsl_01_grate").gameObject);
			m_FieldAnimatorDictionary.Add("coffin", _fieldObjDictionary["coffin"].GetComponent<Animator>());
			m_FieldAnimatorDictionary.Add("sword", _fieldObjDictionary["sword"].GetComponent<Animator>());
			m_FieldAnimatorDictionary.Add("tapestry_a", _fieldObjDictionary["tapestry_a"].GetComponent<Animator>());
			m_FieldAnimatorDictionary.Add("tapestry_b", _fieldObjDictionary["tapestry_b"].GetComponent<Animator>());
			m_FieldAnimatorDictionary.Add("chain_a", _fieldObjDictionary["chain_a"].GetComponent<Animator>());
			m_FieldAnimatorDictionary.Add("chain_b", _fieldObjDictionary["chain_b"].GetComponent<Animator>());
			m_FieldAnimatorDictionary.Add("chain_c", _fieldObjDictionary["chain_c"].GetComponent<Animator>());
			m_FieldAnimatorDictionary.Add("chain_d", _fieldObjDictionary["chain_d"].GetComponent<Animator>());
			m_FieldAnimatorDictionary.Add("chain_e", _fieldObjDictionary["chain_e"].GetComponent<Animator>());
			m_FieldAnimatorDictionary.Add("grate", _fieldObjDictionary["grate"].GetComponent<Animator>());
			_fieldParticleSystemDictionary.Add("opening", _fieldParticles.transform.Find("opening").GetComponent<ParticleSystem>());
			_fieldParticleSystemDictionary.Add("coffin_open", _fieldParticles.transform.Find("coffin_open").GetComponent<ParticleSystem>());
			_fieldParticleSystemDictionary.Add("coffin_close", _fieldParticles.transform.Find("coffin_close").GetComponent<ParticleSystem>());
			_fieldParticleSystemDictionary.Add("coffin_gimic_1", _fieldParticles.transform.Find("coffin_gimic_1").GetComponent<ParticleSystem>());
			_fieldParticleSystemDictionary.Add("coffin_gimic_2", _fieldParticles.transform.Find("coffin_gimic_2").GetComponent<ParticleSystem>());
			_fieldParticleSystemDictionary.Add("fog", _fieldParticles.transform.Find("fog").GetComponent<ParticleSystem>());
			_fieldParticleSystemDictionary.Add("candle", _fieldParticles.transform.Find("candle").GetComponent<ParticleSystem>());
			List<string> list = new List<string>(_fieldObjDictionary.Keys);
			List<GameObject> list2 = new List<GameObject>();
			for (int i = 0; i < _fieldObjDictionary.Count; i++)
			{
				list2.Add(_fieldObjDictionary[list[i]]);
			}
			GameMgr.GetIns().GetEffectMgr().SetUIParticleShader(list2, delegate
			{
				base.SetShaderGlobalColorBG = base.Field.transform.Find("SetMaterialColorBGManager").GetComponent<SetShaderGlobalColorBG>();
				base.IsLoadDone = true;
			}, isBattle: true, isField: true);
		}));
	}

	public override void StartFieldSetEffect(Vector3 pos)
	{
		GameMgr.GetIns().GetEffectMgr().Start(EffectMgr.EffectType.CMN_FIELD_SET_2, pos);
	}

	public override void StartFieldTapEffect(int areaId, Vector3 pos)
	{
		base.StartFieldTapEffect(areaId, pos);
		GameMgr.GetIns().GetEffectMgr().Start(EffectMgr.EffectType.CMN_FIELD_TAP_2_1, pos);
	}

	protected override IEnumerator RunFieldOpening()
	{
		GameMgr.GetIns().GetSoundMgr().PlaySeByStr($"se_field_{_str3DFieldNo}_appear_1", "se_field_" + _str3DFieldNo, 0f, 0L);
		m_FieldAnimatorDictionary["tapestry_a"].speed = 0.4f + Random.value * 0.2f;
		m_FieldAnimatorDictionary["tapestry_b"].speed = 0.4f + Random.value * 0.2f;
		_fieldParticleSystemDictionary["opening"].Play();
		_fieldParticleSystemDictionary["fog"].gameObject.SetActive(value: false);
		_fieldParticleSystemDictionary["candle"].gameObject.SetActive(value: false);
		m_RandomActionTime = 20f;
		_battleCamera.Camera.transform.localPosition = new Vector3(2550f, -830f, -200f);
		_battleCamera.Camera.transform.localRotation = Quaternion.Euler(new Vector3(-19f, -90f, 90f));
		Vector3[] bezierQuad = MotionUtils.GetBezierQuad(new Vector3(2550f, -830f, -200f), new Vector3(840f, -250f, -200f), new Vector3(-240f, -190f, -70f), 10);
		iTween.MoveTo(_battleCamera.Camera.gameObject, iTween.Hash("path", bezierQuad, "movetopath", false, "time", 2f, "islocal", true, "easetype", iTween.EaseType.easeInOutQuad));
		iTween.RotateTo(_battleCamera.Camera.gameObject, iTween.Hash("rotation", new Vector3(-37f, -117f, 107f), "time", 1f, "delay", 1f, "islocal", true, "easetype", iTween.EaseType.easeInOutQuad));
		yield return new WaitForSeconds(0.6f);
		m_FieldAnimatorDictionary["grate"].SetTrigger("Open");
		_fieldParticleSystemDictionary["candle"].gameObject.SetActive(value: true);
		yield return new WaitForSeconds(1.4f);
		GameMgr.GetIns().GetSoundMgr().PlaySe(Se.TYPE.SYS_CAMERA_ZOOM_OUT);
		m_FieldAnimatorDictionary["grate"].SetTrigger("Close");
		_fieldParticleSystemDictionary["fog"].gameObject.SetActive(value: true);
		iTween.MoveTo(_battleCamera.Camera.gameObject, iTween.Hash("position", _battleCamera.BattleCameraPos, "time", 2f, "islocal", true, "easetype", iTween.EaseType.easeInOutExpo));
		iTween.RotateTo(_battleCamera.Camera.gameObject, iTween.Hash("rotation", _battleCamera.BattleCameraRot, "time", 2f, "islocal", true, "easetype", iTween.EaseType.easeInOutExpo));
		yield return new WaitForSeconds(0f);
	}

	protected override IEnumerator RunFieldGimic(GameObject obj)
	{
		string tag = obj.tag;
		if (tag != null && tag == "FieldGimic1" && _gimicCntDictionary[obj.tag] == 0)
		{
			_gimicCntDictionary[obj.tag]++;
			int num = Random.Range(1, 3);
			GameMgr.GetIns().GetSoundMgr().PlaySeByStr($"se_field_{_str3DFieldNo}_gim_{num}", "se_field_" + _str3DFieldNo, 0f, 0L);
			switch (num)
			{
			case 1:
				GameMgr.GetIns().GetSoundMgr().PlaySeByStr(GimicAudioList[0], "se_field_" + _str3DFieldNo, 0f, 0L);
				GameMgr.GetIns().GetSoundMgr().PlaySeByStr(GimicAudioList[1], "se_field_" + _str3DFieldNo, 0f, 0L);
				GameMgr.GetIns().GetSoundMgr().PlaySeByStr(GimicAudioList[2], "se_field_" + _str3DFieldNo, 0f, 0L);
				m_FieldAnimatorDictionary["coffin"].SetTrigger("Open");
				m_FieldAnimatorDictionary["sword"].SetTrigger("Open");
				_fieldParticleSystemDictionary["coffin_open"].Play();
				yield return new WaitForSeconds(1.5f);
				_fieldParticleSystemDictionary["coffin_gimic_1"].Play();
				yield return new WaitForSeconds(2.5f);
				GameMgr.GetIns().GetSoundMgr().PlaySeByStr(GimicAudioList[4], "se_field_" + _str3DFieldNo, 0f, 0L);
				m_FieldAnimatorDictionary["coffin"].SetTrigger("Close");
				yield return new WaitForSeconds(1f);
				m_FieldAnimatorDictionary["sword"].SetTrigger("Close");
				yield return new WaitForSeconds(1f);
				GameMgr.GetIns().GetSoundMgr().PlaySeByStr(GimicAudioList[6], "se_field_" + _str3DFieldNo, 0f, 0L);
				_fieldParticleSystemDictionary["coffin_close"].Play();
				yield return new WaitForSeconds(1f);
				break;
			case 2:
				m_FieldAnimatorDictionary["coffin"].SetTrigger("Act");
				m_FieldAnimatorDictionary["sword"].SetTrigger("Act");
				yield return new WaitForSeconds(0.5f);
				break;
			}
			GameMgr.GetIns().GetSoundMgr().PlaySeByStr(GimicAudioList[5], "se_field_" + _str3DFieldNo, 0f, 0L);
			_gimicCntDictionary[obj.tag] = 0;
		}
	}

	protected override IEnumerator RunFieldShake()
	{
		m_FieldAnimatorDictionary["chain_a"].speed = 0.8f + Random.value * 0.4f;
		m_FieldAnimatorDictionary["chain_b"].speed = 0.8f + Random.value * 0.4f;
		m_FieldAnimatorDictionary["chain_c"].speed = 0.8f + Random.value * 0.4f;
		m_FieldAnimatorDictionary["chain_d"].speed = 0.8f + Random.value * 0.4f;
		m_FieldAnimatorDictionary["chain_e"].speed = 0.8f + Random.value * 0.4f;
		m_FieldAnimatorDictionary["chain_a"].SetTrigger("Shake");
		m_FieldAnimatorDictionary["chain_b"].SetTrigger("Shake");
		m_FieldAnimatorDictionary["chain_c"].SetTrigger("Shake");
		m_FieldAnimatorDictionary["chain_d"].SetTrigger("Shake");
		m_FieldAnimatorDictionary["chain_e"].SetTrigger("Shake");
		m_FieldAnimatorDictionary["tapestry_a"].speed = 0.8f + Random.value * 0.4f;
		m_FieldAnimatorDictionary["tapestry_b"].speed = 0.8f + Random.value * 0.4f;
		m_FieldAnimatorDictionary["tapestry_a"].SetTrigger("Shake");
		m_FieldAnimatorDictionary["tapestry_b"].SetTrigger("Shake");
		if (_gimicCntDictionary["FieldGimic1"] == 0)
		{
			m_FieldAnimatorDictionary["coffin"].SetTrigger("Shake");
			m_FieldAnimatorDictionary["sword"].SetTrigger("Shake");
		}
		yield return new WaitForSeconds(3f);
		m_FieldAnimatorDictionary["tapestry_a"].speed = 0.4f + Random.value * 0.2f;
		m_FieldAnimatorDictionary["tapestry_b"].speed = 0.4f + Random.value * 0.2f;
		yield return new WaitForSeconds(0f);
	}

	public override void UpdateFieldRandom()
	{
		if (IsFieldRandom)
		{
			m_RandomActionTime -= Time.deltaTime;
			if (m_RandomActionTime <= 0f)
			{
				m_FieldAnimatorDictionary["tapestry_a"].SetTrigger("LoopRandom");
				m_FieldAnimatorDictionary["tapestry_b"].SetTrigger("LoopRandom");
				m_RandomActionTime = Random.value * 20f + 20f;
			}
		}
	}
}
